<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


if(!defined("HPEprotectmultiincnwsparse")) {

define("HPEprotectmultiincnwsparse", 1);


class HPENewsSource {

	var $id = 0;
	var $name = "";
	var $url = "";
	var $reqlogo = "";
	var $host = "";
	var $port = 80;
	var $path = "";
	var $header = "";
	var $source = "";
	var $language = "EN";

	var $maxitems = 0;
	var $timeout = 1800;
	var $decay = 3;
	var $type = 0;

	var $param1 = "";
	var $param2 = "";
	var $param3 = "";
	var $description = "";


	function HPENewsSource()
	{
	}


	function init()
	{
		$this->id = 0;
		$this->name = "";
		$this->url = "";
		$this->reqlogo = "";
		$this->host = "";
		$this->port = 80;
		$this->path = "";
		$this->header = "";
		$this->source = "";
		$this->language = "EN";

		$this->type = 0;
		$this->maxitems = 0;
		$this->timeout = 1800;

		$this->param1 = "";
		$this->param2 = "";
		$this->param3 = "";
		$this->description = "";
		
		$this->decay = 3;
	}


	function read($id)
	{
		if($id == $this->id) return;
		$this->id = 0;

		global $HPEtheDB;

		$this->init();

		global $HPEinc;
		global $HPEtheConfig;
		$cache = "$HPEinc/$HPEtheConfig->cachepath/site.$id.inc";
		if(file_exists($cache)) {

			include $cache;

		} else {

			$query = "SELECT * FROM $HPEtheDB->dbtnewssites WHERE siteid = $id ;";
			$row = $HPEtheDB->one_array($query);

			if($row) {

				$this->id = $id;

				$this->name = stripslashes($row["sitename"]);
				$this->url = $row["siteurl"];
				$this->host = $row["sitehost"];
				$this->port = $row["siteport"];
				$this->path = $row["newspath"];
				$this->header = $row["header"];
				$this->language = $row["language"];


				$this->type = $row["newstype"];
				$this->maxitems = $row["maxitems"];
				$this->timeout = $row["timeout"];
				$this->decay = $row["decay"];

				$this->param1 = stripslashes($row["param1"]);
				$this->param2 = stripslashes($row["param2"]);
				$this->param3 = stripslashes($row["param3"]);
				$this->description = stripslashes($row["description"]);

				$cf = fopen($cache, "w");
				if($cf) {
					flock($cf, 2);
					fputs($cf, "<?\n\n" );

					fputs($cf, "\$this->name = \"" . $this->name . "\";\n" );
					fputs($cf, "\$this->url = \"$this->url\";\n" );
					fputs($cf, "\$this->host = \"$this->host\";\n" );
					fputs($cf, "\$this->port = $this->port;\n" );
					fputs($cf, "\$this->path = \"$this->path\";\n" );
					fputs($cf, "\$this->header = '" . addslashes($this->header) . "';\n" );
					fputs($cf, "\$this->language = \"$this->language\";\n" );

					fputs($cf, "\$this->id = $this->id;\n" );
					fputs($cf, "\$this->type = $this->type;\n" );
					fputs($cf, "\$this->maxitems = $this->maxitems;\n" );
					fputs($cf, "\$this->timeout = $this->timeout;\n" );
					fputs($cf, "\$this->decay = $this->decay;\n" );

					fputs($cf, "\$this->param1 = '" . addslashes($this->param1) . "';\n" );
					fputs($cf, "\$this->param2 = '" . addslashes($this->param2) . "';\n" );
					fputs($cf, "\$this->param3 = '" . addslashes($this->param3) . "';\n" );
					fputs($cf, "\$this->description = \"" . $this->description . "\";\n" );

					fputs($cf, "\n?>\n" );

					flock($cf, 3);
					fclose($cf);
				}

			} else {

				echo "DBERR : " . $HPEtheDB->dberr;
				return -2;

			}

		}

		$this->source = "http://" . $this->host . ":" . $this->port . $this->path;

		return 0;
	}

};





class HPENewsParser extends HPENewsSource {

	var $cachefile = "";	// where to cache the data
	var $nocache = 0;		// don't cache
	var $forcecache = 0;	// use cache even if it has timed out
	var $filedate = 0;		// date of parse

	var $itemcount = 0;		// number of news items stored
	var $itemparsed = 0;	// number of news items parsed
	var $newitems = 0;		// number of new items since previous parse (valid only if storenewsindb)

	var $thetitle;			// parsed title for the source
	var $thelink;			// parsed link
	var $items;				// array of items
	var $links;				// array of links
	var $descs;				// array of descriptions



	// private vars
	var $donedbupd = 0;		// true if parsed channel info has only been written to cache file
	var $putchannel = 0;

	var $xmlparser = 0;		// PHP XML parser object

	var $filterFct = "";
	var $filterFctParam = "";

	var $infile;
	var $outfile;



	function HPENewsParser()
	{
		$this->HPENewsSource();
	}


	// return :
	// -1 : ERROR
	//  0 : OK, new load
	//  1 : OK, cache

	function parsedbnews($id, $maxitems = 0)
	{
		global $HPEtheDB;
		$this->reset();

//		if($id == 229) $this->nocache = 1; else $this->nocache = 0;
//		$this->nocache = 1;

		$result = $this->read($id);
		echo "$id ";

		if($result != 0) return $result;

		global $HPEinc;
		global $HPEtheConfig;
		$cache = "$HPEinc/$HPEtheConfig->cachepath/ncache." . trim($id) . ".cache";
		
		if($this->testCache($cache) == 0) {
			echo "using cache\n";
			return $this->loadcache(1, $maxitems);
		}

		if($this->param3 != "") {
			$info = split(",", $this->param3);
			$this->setFilterFct($info[0],
				(isset($info[1]) ? $this->filterFctParam = $info[1] : ""));
		}


		$this->beginNews();

		$n = count($HPEtheConfig->newsparsers);
		for($i=0; $i<$n; $i++)
			if($HPEtheConfig->newsparsers[$i]["id"] == $this->type) break;
		echo $HPEtheConfig->newsparsers[$i]["name"] . " [$i]\n";
		if($i == $n) {
			echo "Wrong news type " . $this->type . " for news site $id\n";
			$result = -1;
		} else {
			eval("\$result = " . $HPEtheConfig->newsparsers[$i]["fct"] . "();");
		}
		if($this->itemcount == 0 && $result == 0) $result = -2;

		$this->endNews($result == 0 ? 1 : 0);

		if($result < 0) {

			$query = "REPLACE $HPEtheDB->dbtnewsupdates SET id=$id, moddate=NOW(), ncount=0;";
			$HPEtheDB->query($query);

			return $this->loadcache(-1, $maxitems);

		} elseif($result == 0) {  // new load formated, no cache, maybe empty

			$query = "REPLACE $HPEtheDB->dbtnewsupdates SET id=$id, moddate=NOW(), ncount=". $this->itemcount . ";";
			$HPEtheDB->query($query);

		}

		return $result;
	}


	function parseurlnews($url, $maxitems = 0)
	{
		global $HPEtheDB;
		$this->reset();

		global $HPEinc;
		global $HPEtheConfig;
		$cache = "$HPEinc/$HPEtheConfig->cachepath/ncache." . urlencode(trim($url)) . ".cache";
		
		if($this->testCache($cache) == 0) {
			echo "using cache\n";
			return $this->loadcache(1, $maxitems);
		}

		$this->infile = fopen($url, "r");
		if($this->infile == 0) return -1;
		
		$this->beginNews();

		$this->type = 0;
		echo $HPEtheConfig->newsparsers[0]["name"] . " [0]\n";
		eval("\$result = " . $HPEtheConfig->newsparsers[0]["fct"] . "();");
		if($this->itemcount == 0 && $result == 0) $result = -2;

		$this->endNews($result == 0 ? 1 : 0);

		return $result;
	}


	// private functions
	function reset()
	{
		$this->cachefile = "";
		$this->nocache = 0;
		$this->forcecache = 0;

		$this->itemcount = 0;
		$this->newitems = 0;

		$this->infile = 0;
		$this->outfile = 0;

		$this->donedbupd = 0;
		$this->putchannel = 0;

		$this->thetitle = "";
		$this->thelink = "";
		$this->items = array();
		$this->links = array();
		$this->descs = array();

		$this->filterFct = "";
		$this->filterFctParam = "";
	}


	function setFilterFct($fct, $fctp)
	{
		if($this->param3 != "") {
			$info = split(",", $this->param3);
			$this->filterFct = $info[0];
			if(isset($info[1])) $this->filterFctParam = $info[1];
		}
	}


	// Is the cache valid: return 0 if new parsing is required
	function testCache($cache = "")
	{
		global $HPEinc;
		global $HPEtheConfig;

		if($cache != "") $this->cachefile = $cache;
					else $this->cachefile = "$HPEinc/$HPEtheConfig->cachepath/ncache." . $this->host . ".cache";

		$usecache = 0;
		if(file_exists($this->cachefile)) {
			$ntime = Time();
			$ctime = fileMtime($this->cachefile);
			$dtime = $ntime - $ctime;
			if(fileSize($this->cachefile) < 20) $usecache = 0;
			elseif($this->forcecache || $HPEtheConfig->bgupdate || $HPEtheConfig->timedout) {
				$usecache = 1;
			} elseif($this->nocache || $dtime > $ntime || $dtime > $this->timeout) $usecache = 0;
			else $usecache = 1;
		}

		return ($usecache ? 0 : 1);
	}


	// if the cache is valid, this loads the cache file
	function loadCache($res, $maxitems = 0)
	{
		if(file_exists($this->cachefile) == false) return -2;

		$info = @file($this->cachefile);
		$n = count($info);
		if($n == 0) {
			@unlink($this->cachefile);
			return -1;
		}

		$this->thetitle = $info[0];
		$this->thelink  = $info[1];
		$this->filedate  = $info[2];

		$ic = 0;

		if($this->type != 3 && $this->type != 4) {

			for($i = 3; $i<$n; $i+=3) {
				$this->items[] = $info[$i];
				$this->links[] = $info[$i + 1];
				$this->descs[] = "";
				$ic++;
				if($maxitems && $ic >= $maxitems) break;
			}

		} else {

			for($i = 3; $i<$n; $i++) {
				$this->items[] = $info[$i];
				$ic ++;
			}

		}

		$this->itemcount = $ic;

		return $res;
	}


	// opens cache file, keep fileid in $this->outfile, returns 1 on error
	function beginNews()
	{
		$this->outfile = fopen($this->cachefile . ".tmp", "w");
		if($this->outfile == false) {
        	echo "Error opening cache file " . $this->cachefile . ".tmp\n";
			return 1;
		}
		flock($this->outfile, 2);

		$ctime = @fileMtime($this->cachefile . ".tmp");
		$this->filedate = Date("G:i m/d/y", $ctime);

		return 0;
	}


	// close opened cache file and connection
	// if $success, store cache file permanently, otherwise delete temp file
	function endNews($success)
	{
		global $HPEtheConfig;

		fclose($this->outfile);
		if($this->infile) fclose($this->infile);
		if($success && !$HPEtheConfig->timedout)
				 @rename($this->cachefile . ".tmp", $this->cachefile);
			else @unlink($this->cachefile . ".tmp");
	}


	// opens a socket to the news source, returns 1 on error
	function openNews() 
	{
		if($this->infile != 0) return 0;

		$hostname = $this->host;
		$url = $this->path;
		$port = $this->port;

        $this->infile = fsockopen($this->host, $this->port, &$errno, &$errstr);
		if(!$this->infile) {
       		echo "Error connecting to $this->host: $errno $errstr\n";
			fclose($this->outfile);
			return 1;
		}

		$uri = urldecode($this->path);
		fputs($this->infile, "GET $uri HTTP/1.0\r\n");
		fputs($this->infile, "User-Agent: Wget/1.5.3\r\n");
		if($this->port == 80) fputs($this->infile, "Host: " . $this->host . "\r\n");
						 else fputs($this->infile, "Host: " . $this->host . ":" . $this->port . "\r\n");
		fputs($this->infile, "Accept: */*\r\n");
		if($this->header != "") fputs($this->infile, $this->header . "\r\n");
		fputs($this->infile, "\r\n");

		$linelength = 1024;
		$str = trim(fgets($this->infile, $linelength));

		// read first file, should be the header info
		if(ereg("^HTTP/1.[01] ([0-9]{3}) (.*)$", $str, $regs)) {
			if($regs[1] != "200") {
				echo "HTTP Error '$regs[1]' '$regs[2]'\n";
				return 1;
			}
		} else {
			echo "Wrong header '$str'\n";
			return 1;
		}

		$header_passed = 0;
		while (!feof($this->infile) && !$header_passed) {
			$str = trim(fgets($this->infile, $linelength));
//echo "-$str-<BR>\n";
			if ($str == "") {
				$header_passed = 1;
			}
		}

		return 0;
	}


	// write parsed site info to temp cache file
	function writeHeader($title, $url)
	{
		if($this->putchannel) return;

		if($title == "") $title = $this->name;
		if($url == "") $url = $this->url;

		$str = ereg_replace("\"", "", $url);
		fputs($this->outfile, "$title\n$url\n" . $this->filedate . "\n");
		$this->putchannel = 1;

		$this->thetitle = $title;
		$this->thelink = $url;
	}


	// write parsed news item to temp cache file
	function writeItem($item, $url, $comment = "")
	{
		global $HPEtheConfig;

		if($HPEtheConfig->chkTimeOut()) $this->maxitems = $this->itemcount;

		if($item == "") return;

		$item = trim(eregi_replace("&nbsp;", " ", $item));
		if($item == "") return;

		$item = eregi_replace("&gt;", ">", $item);
		$item = eregi_replace("&lt;", "<", $item);
		$item = eregi_replace("&gt;", ">", $item);
		$item = ereg_replace("&*#37;", "'", $item);
		$item = ereg_replace("&*#38;", "", $item);
		$item = ereg_replace("&*#34;", "\"", $item);
		$item = eregi_replace("&apos;", "'", $item);
		$item = eregi_replace("&amp;#13;", "", $item);

		$url = ereg_replace('"', "", trim($url));

		$this->itemparsed++;

		if($this->filterFct != "") {
			$fct = $this->filterFct;
			$fct($item, $url, $this->filterFctParam);
			if($item == "") return;
		}

		if($url == "") $url = $this->url;
		if(!eregi("^http:", $url)) return;

//echo "== $this->itemcount '$item' '$url' <BR>\n";
		fputs($this->outfile, "$item\n$url\n$comment\n");

		$this->itemcount++;

		$this->items[] = $item;
		$this->links[] = $url;


		global $HPEtheDB;
		if($HPEtheConfig->storenewsindb != 1 || $this->donedbupd) return;

		$item = addslashes($item);
		if(strlen($item) > 100)
			$item = substr($item, 0, 97) . "...";
		$url = addslashes($url);
		$query = "SELECT newsid FROM $HPEtheDB->dbtnewsitems WHERE " .
				 "newsitem='$item' AND " .
				 "newslink='$url' AND " .
				 "source=" . $this->id . ";";
		if($HPEtheDB->one_data($query) == 0) {
			$query = "INSERT $HPEtheDB->dbtnewsitems SET " .
				 "newsitem='$item', " .
				 "newslink='$url', " .
				 "adddate=NOW()-" . 60 * $this->newitems . ", " .
				 "source=" . $this->id . ";";
			if($HPEtheDB->query($query) == 0) echo $HPEtheDB->dberr . "\n";
			else $this->newitems++;
		} else $this->donedbupd = 1;


	}

};




function HPEFilterPrependURL(&$item, &$url, $param)
{
	if(!eregi("^http:.*", $url)) $url = $param . $url;
}

function HPEFilterPrependURLSkipEven(&$item, &$url, $param)
{
	global $HPEtheNEWSparser;
	if(($HPEtheNEWSparser->itemparsed % 2) == 0) $item = "";
	$url = $param . $url;
}

function HPEFilterPrependURLSkipOdd(&$item, &$url, $param)
{
	global $HPEtheNEWSparser;
	if(($HPEtheNEWSparser->itemparsed % 2) == 1) $item = "";
	$url = $param . $url;
}


for($i=0; $i<count($HPEtheConfig->newsparsers); $i++) {
	include $HPEtheConfig->newsparsers[$i]["path"];
}


} // $HPEprotectmultiincnwsparse

?>
