<?

/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

if(!defined("HPEprotectmultiincnewsmod")) {
define("HPEprotectmultiincnewsmod", 1);

require "$HPEinc/newsparser.php3";
$HPEtheNEWSparser = new HPENewsParser();


class HPENewsModule {

	function HPENewsModule() 
	{
	}

	function showNewsURL($url, $maxitems = 0)
	{
		global $HPEtheNEWSparser;
		global $HPEtheSession;
		global $HPEtheConfig;

		$this->id = -1;

		if(!isset($HPEtheSession) || !$HPEtheSession->isadmin || !$HPEtheConfig->errorall) echo "<!-- ";
		$res = $HPEtheNEWSparser->parseurlnews($url, 0);
		echo " -->\n";

		return $this->DisplayNews($res, $maxitems);
	}


	function showNews($id, $maxitems = 0, $pos = -1)
	{
		global $HPEtheNEWSparser;
		global $HPEtheSession;
		global $HPEtheConfig;

		$this->id = $pos;

		if(!isset($HPEtheSession) || !$HPEtheSession->isadmin || !$HPEtheConfig->errorall) echo "<!-- ";
		$res = $HPEtheNEWSparser->parsedbnews($id, 0);
		echo " -->\n";

		return $this->DisplayNews($res, $maxitems);
	}


	function DisplayNews($res, $maxitems)
	{
		global $HPEtheNEWSparser;
		global $HPEtheSession;
		global $HPEtheConfig;
		global $page;

		global $HPEtheThemeMaker;

		if($res == -1 && $HPEtheNEWSparser->itemcount == 0) {
			if($HPEtheNEWSparser->id == 0) {
				return $HPEtheThemeMaker->TPLBlockModule("Site Does Not Exist",
														 $HPEtheConfig->siteurl,
														 Date("G:i m/d/y"),
														 "This site is no longer available");
			} else {
				return $HPEtheThemeMaker->TPLBlockModule($HPEtheNEWSparser->name,
														 $HPEtheNEWSparser->url,
														 Date("G:i m/d/y"),
														 "This site is not available at this time");
			}
		}

		if($res == 0) $message = "(fresh)";
		elseif($res == -1) $message = "(error cache)";
		else $message = "";

		$comment = "Update:&nbsp;$HPEtheNEWSparser->filedate $message ";
		if($HPEtheNEWSparser->reqlogo != "")
			$comment = "<img align=right src=\"" . $HPEtheConfig->siteurl . "$HPEtheNEWSparser->reqlogo\">" . $comment;

		if(isset($HPEtheSession)) {
			if($HPEtheSession->userid != 0 && $this->id != -1)
				$comment .= "[<A HREF=\"editnews.php3?onpage=$page&module=" . $this->id . "&done=index.php3%3Fpage%3D$page\">edit</A>|" .
							"<A HREF=\"editpage.php3?EDITPAGE=$page&OP=REMOVE&PARAM=" . $this->id . "&done=index.php3%3Fpage%3D$page\">close</A>]";
				else $comment .= "&nbsp;";
			if($HPEtheSession->isadmin) $comment .= " [<A HREF=\"HPE/admin/index.php3?pg=editsite&id=$HPEtheNEWSparser->id&done=" . $HPEtheConfig->siteurl . "%3Fpage%3D$page\">site</A>]";
		}

		if($HPEtheNEWSparser->itemcount == 0) {
			return $HPEtheThemeMaker->TPLBlockModule($HPEtheNEWSparser->name,
													 $HPEtheNEWSparser->url,
													 $comment,
													 "No Items Found!",
													 $HPEtheNEWSparser->description);
		}

		if($HPEtheNEWSparser->type != 3 && $HPEtheNEWSparser->type != 4) {
			$HPEtheThemeMaker->TPLListModuleBegin(trim($HPEtheNEWSparser->thetitle),
												  trim($HPEtheNEWSparser->thelink),
												  $comment,
												  $HPEtheNEWSparser->description);
			for($i = 0; $i<$HPEtheNEWSparser->itemcount; $i++) {
				if($maxitems && $i >= $maxitems) break;
				$item = trim($HPEtheNEWSparser->items[$i]);
				if($item != "") {
					$item = ereg_replace("&lt;", "<", $item);
					$item = ereg_replace("&gt;", ">", $item);
					$url = trim($HPEtheNEWSparser->links[$i]);
					if($url == "") $url = $HPEtheNEWSparser->url;
					$HPEtheThemeMaker->TPLListModuleAddItem($item, $url, "");
				}
			}
			return $HPEtheThemeMaker->TPLListModuleEnd();

		} else {

			$s = "";
			for($i = 0; $i<$HPEtheNEWSparser->itemcount; $i++) 
				$s .= $HPEtheNEWSparser->items[$i];
			return $HPEtheThemeMaker->TPLBlockModule($HPEtheNEWSparser->name,
													 $HPEtheNEWSparser->url,
													 $comment,
													 $s,
													 $HPEtheNEWSparser->description);

		}

	}


	function show($i, $param)
	{
		global $HPEtheNEWSparser;
		global $HPEtheConfig;

		$res = "";
		if($param) {
			$items = split(",", $param);
			if(count($items) == 1) $items[1] = 0;
			$res = $this->showNews($items[0], $items[1], $i);
		}

		if($HPEtheConfig->chkTimeOut()) $HPEtheNEWSparser->forcecache = 1;

		return $res;
	}


	function command($cmd, &$module)
	{
		if($module["type"] != 0) return -1;

		global $HPEtheDB;
		if($cmd == "GETNAME") {
			$query = "SELECT sitename FROM $HPEtheDB->dbtnewssites WHERE siteid=" . $module["params"][0] . ";";
			$module["name"] = $HPEtheDB->one_data($query);
			return $module["name"];
		}
		return -1;
	}


};


} // $HPEprotectmultiincnewsmod

?>
