<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

if(!defined("HPEPHPNewsParser")) {
define("HPEPHPNewsParser", 1);


require "$HPEinc/plugins/xmlbaseparser.php3";
require "$HPEinc/tokenizer.php3";


class HPEXMLPHPNewsParser extends HPEXMLBaseParserTools
{

	function HPEXMLPHPNewsParser()
	{
		$this->HPEXMLBaseParserTools();
	}

	function parse()
	{
		global $HPEtheNEWSparser;
		
		$this->reset();

		if($HPEtheNEWSparser->openNews()) return -1;

		$tokenizer = new HPETokenizer($HPEtheNEWSparser->infile);

		if($HPEtheNEWSparser->param1 != "") {
			$lt = split(",", $HPEtheNEWSparser->param1);
			$this->tagchannel = $lt[0];
			$this->tagchtitle = $lt[1];
			$this->tagchlink  = $lt[2];
		}

		if($HPEtheNEWSparser->param2 != "") {
			$lt = split(",", $HPEtheNEWSparser->param2);
			$this->tagitem    = $lt[0];
			$this->tagittitle = $lt[1];
			$this->tagitlink  = $lt[2];
//			echo $lt[0] . "-" . $lt[1] . "-" . $lt[2] . "<BR>\n";
		}

		while (!feof($HPEtheNEWSparser->infile)) {

			$param = array();
			$str = "";
			$type = $tokenizer->getNextToken($str, $param);
			if($type == 1) {
				$this->startElement($str, "");
			} elseif($type == 2) {
				$this->endElement($str);
			} elseif($type == 0) {
				$this->characterData($str);
			}
			if($HPEtheNEWSparser->maxitems > 0 && $HPEtheNEWSparser->itemcount >= $HPEtheNEWSparser->maxitems) break;
		}


		if($HPEtheNEWSparser->itemcount == 0) $HPEtheNEWSparser->writeHeader($HPEtheNEWSparser->name, $HPEtheNEWSparser->url);

		return 0;
	}

};


function HPEXMLPHPParse()
{
	$work = new HPEXMLPHPNewsParser();
	return $work->parse();
}



} // HPEPHPNewsParser


?>
