<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

class HPE3colsPager
{
	var $pagedesc;
	var $pageitems;
	var $nbitems;
	var $pageid;
	var $pagenum;

	function HPE3colsPager($page)
	{
		global $HPEtheUser;

		$this->pageid  = $HPEtheUser->pageids[$page];
		$this->pagenum = $page;
	}


	function parse()
	{
		global $HPEtheDB;

		$this->pagedesc  = array(array(), array(), array());
		$this->pageitems = array();
		$this->nbitems   = 0;

		$query = "SELECT * FROM $HPEtheDB->dbtpages WHERE pageid=$this->pageid;";
		$row = $HPEtheDB->one_array($query);
		if($row) {

			$this->pagetitle = $row["title"];
			$this->pagetype = $row["pgtype"];

			if($row["layout"] != "") {
				$cols = split('\|', $row["layout"]);

				for($j=0; $j<count($cols); $j++) {

					if($cols[$j] == "--" || $cols[$j] == "") continue;

					$elts = split(";", $cols[$j]);

					for($i=0; $i<count($elts); $i++) {

						$e = split(",", $elts[$i]);
						if(count($e) < 1 || $e[0] == "") continue;

						$this->pagedesc[$j][$i] = $this->nbitems;

						$this->pageitems[$this->nbitems] = array(
														"pos" => "$j,$i",
														"type" => $e[0],
														"params" => array()
													);

						for($l=1; $l<count($e); $l++)
							$this->pageitems[$this->nbitems]["params"][$l - 1] = $e[$l];

						$this->nbitems++;

					}

				}
			}
	
		}

	}


	function isNewsOnPage($newsid)
	{
		if($this->nbitems == 0) return -1;
		for($i=0; $i<$this->nbitems; $i++) {
			if($this->pageitems[$i]["params"][0] == $newsid) return $i;
		}
		return -1;
	}


	function getModuleInfo($n, &$type, &$param)
	{
		$type = $this->pageitems[$n]["type"];
		$param = implode(",", $this->pageitems[$n]["params"]);
	}

};


?>
