<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


if(!defined("HPEprotectmultiincxmlbaseparse")) {
define("HPEprotectmultiincxmlbaseparse", 1);


class HPEXMLBaseParserTools {

	var $inchar = "";
	var $infile = 0;
	var $outfile = 0;
	var $putchannel = 0;

	var $inchannel = 0;
	var $initem = 0;
	var $intitle = 0;
	var $intxtinput = 0;
	var $inlink = 0;
	var $inimage = 0;

	var $chtitle = "";
	var $churl = "";
	var $ittitle = "";
	var $iturl = "";
	var $tiname = "";
	var $tiurl = "";
	var $tititle = "";
	var $imgtitle = "";
	var $imgurl = "";

	var $tagitem = "ITEM";
	var $tagittitle = "TITLE";
	var $tagitlink = "LINK";
	var $tagchannel = "CHANNEL";
	var $tagchtitle = "TITLE";
	var $tagchlink = "LINK";
	var $tagimage = "IMAGE";
	var $tagimgtitle = "TITLE";
	var $tagimglink = "LINK";


	function HPEXMLBaseParserTools()
	{
	}


	function reset()
	{
		$this->inchar = "";
		$this->infile = 0;
		$this->outfile = 0;
		$this->filedate = 0;
		$this->putchannel = 0;
		$this->itemcount = 0;
		$this->newitems = 0;

		$this->inchannel = 0;
		$this->initem = 0;
		$this->intitle = 0;
		$this->inlink = 0;
		$this->inimage = 0;
		$this->intxtinput = 0;

		$this->chtitle = "";
		$this->churl = "";
		$this->ittitle = "";
		$this->iturl = "";

		$this->imgtitle = "";
		$this->imgurl = "";

		$this->tiname = "";
		$this->tiurl = "";
		$this->tititle = "";

		$this->tagitem = "ITEM";
		$this->tagittitle = "TITLE";
		$this->tagitlink = "LINK";
		$this->tagchannel = "CHANNEL";
		$this->tagchtitle = "TITLE";
		$this->tagchlink = "LINK";
		$this->tagimage = "IMAGE";
		$this->tagimgtitle = "TITLE";
		$this->tagimglink = "LINK";
	}


	function startElement($name, $attrs)
	{
		global $HPEtheNEWSparser;

		if($name == $this->tagitem) {
			if($this->inchannel) {
				$this->inchannel = 0;
				$HPEtheNEWSparser->writeHeader($this->chtitle, $this->churl);
			}
			if($this->initem) {
				$HPEtheNEWSparser->writeItem($this->ittitle, $this->iturl);
			}
			$this->initem = 1;
			$this->ittitle = "";
			$this->iturl = "";
		} elseif($name == $this->tagchtitle && $this->inchannel) {
			$this->intitle = 1;
		} elseif($name == $this->tagittitle && $this->initem) {
			$this->intitle = 1;
		} elseif($name == $this->tagimgtitle && $this->inimage) {
			$this->intitle = 1;
		} elseif($name == $this->tagitlink) {
			$this->inlink = 1;
		} elseif($name == $this->tagchlink) {
			$this->inlink = 1;
		} elseif($name == $this->tagimglink) {
			$this->inlink = 1;
		} elseif($name == $this->tagimage) {
			$this->inimage = 1;
			$this->imgtitle = "";
			$this->imgurl = "";
		} elseif($name == $this->tagchannel) {
			$this->inchannel = 1;
			$this->chtitle = "";
			$this->churl = "";
		}
	}


	function endElement($name)
	{
		global $HPEtheNEWSparser;

		if($name == $this->tagitem) {
                $this->initem = 0;
                $HPEtheNEWSparser->writeItem($this->ittitle, $this->iturl);
        } elseif($name == $this->tagittitle) {
                $this->intitle = 0;
        } elseif($name == $this->tagchtitle) {
                $this->intitle = 0;
        } elseif($name == $this->tagimgtitle) {
                $this->intitle = 0;
        } elseif($name == $this->tagitlink) {
                $this->inlink = 0;
        } elseif($name == $this->tagchlink) {
                $this->inlink = 0;
        } elseif($name == $this->tagimglink) {
                $this->inlink = 0;
        } elseif($name == $this->tagimage) {
                $this->inimage = 0;
        } elseif($name == $this->tagchannel) {
				if($this->inchannel) $HPEtheNEWSparser->writeHeader($this->chtitle, $this->churl);
                $this->inchannel = 0;
                $this->initem = 0;
        }

	}


	function characterData($data)
	{
        $str = trim($data);
        if($str == "") return;
        if($this->intitle) {
                if($this->inimage) $this->imgtitle .= $str . " ";
                elseif($this->inchannel) $this->chtitle .= $str . " ";
                elseif($this->initem) $this->ittitle .= $str;
                elseif($this->intxtinput) $this->tititle .= $str . " ";
        } elseif($this->inlink) {
                if($this->inimage) $this->imgurl .= $str;
                elseif($this->inchannel) $this->churl .= $str;
                elseif($this->initem && $this->iturl == "") $this->iturl = $str;
                elseif($this->intxtinput) $this->tiurl .= $str;
        }	
	}

};

} // $HPEprotectmultiincxmlbaseparse

?>
