# phpMyAdmin MySQL-Dump
# http://phpwizard.net/phpMyAdmin/
#
# Host: localhost Database : newsisfree

# --------------------------------------------------------
#
# Table structure for table 'NewsCats'
#

CREATE TABLE NewsCats (
   categorie tinyint(4) unsigned DEFAULT '0' NOT NULL auto_increment,
   name varchar(50) NOT NULL,
   namefr varchar(50) NOT NULL,
   namege varchar(50) NOT NULL,
   parentcat tinyint(4) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (categorie),
   KEY categorie (categorie)
);


# --------------------------------------------------------
#
# Table structure for table 'NewsItems'
#

CREATE TABLE NewsItems (
   newsid int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   newsitem varchar(100) NOT NULL,
   newslink text NOT NULL,
   adddate timestamp(14),
   source int(10) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (newsid),
   KEY adddate (adddate),
   KEY newsitem (newsitem)
);


# --------------------------------------------------------
#
# Table structure for table 'NewsSites'
#

CREATE TABLE NewsSites (
   siteid smallint(5) unsigned DEFAULT '0' NOT NULL auto_increment,
   sitename char(255) NOT NULL,
   sitehost char(255) NOT NULL,
   siteport smallint(6) DEFAULT '80' NOT NULL,
   newspath char(255) NOT NULL,
   newstype tinyint(3) unsigned DEFAULT '0' NOT NULL,
   description char(255) NOT NULL,
   param1 char(255) NOT NULL,
   param2 char(255) NOT NULL,
   siteurl char(255) NOT NULL,
   categorie tinyint(4) DEFAULT '0' NOT NULL,
   adddate timestamp(14),
   maxitems tinyint(3) unsigned DEFAULT '0' NOT NULL,
   language char(2) DEFAULT 'EN' NOT NULL,
   icon char(255) NOT NULL,
   moddate timestamp(14),
   timeout mediumint(8) unsigned DEFAULT '3600' NOT NULL,
   decay tinyint(3) unsigned DEFAULT '3' NOT NULL,
   param3 char(255) NOT NULL,
   header char(255) NOT NULL,
   editor tinyint(3) unsigned DEFAULT '0' NOT NULL,
   media tinyint(3) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (siteid),
   KEY siteid (siteid),
   UNIQUE siteid_2 (siteid)
);


# --------------------------------------------------------
#
# Table structure for table 'NewsUpdateSeq'
#

CREATE TABLE NewsUpdateSeq (
   seq char(1) NOT NULL,
   nextval bigint(20) unsigned DEFAULT '0' NOT NULL auto_increment,
   PRIMARY KEY (seq),
   KEY nextval (nextval)
);


# --------------------------------------------------------
#
# Table structure for table 'NewsUpdates'
#

CREATE TABLE NewsUpdates (
   id int(10) unsigned DEFAULT '0' NOT NULL,
   moddate timestamp(14),
   ncount tinyint(3) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (id),
   UNIQUE id (id)
);


# --------------------------------------------------------
#
# Table structure for table 'Pages'
#

CREATE TABLE Pages (
   pageid int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   userid int(10) unsigned DEFAULT '0' NOT NULL,
   title varchar(20) NOT NULL,
   layout text NOT NULL,
   specboxes varchar(255) NOT NULL,
   pgtype tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (pageid)
);


# --------------------------------------------------------
#
# Table structure for table 'UserSession'
#

CREATE TABLE UserSession (
   userid int(10) unsigned DEFAULT '0' NOT NULL,
   lastaccess timestamp(14),
   sessionid varchar(10) NOT NULL,
   PRIMARY KEY (sessionid),
   UNIQUE sessionid (sessionid)
);


# --------------------------------------------------------
#
# Table structure for table 'Users'
#

CREATE TABLE Users (
   userid int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
   userlogin tinytext NOT NULL,
   passwd tinytext NOT NULL,
   name tinytext NOT NULL,
   pagetitles tinytext NOT NULL,
   pageids tinytext NOT NULL,
   email tinytext NOT NULL,
   lang char(2) DEFAULT 'EN' NOT NULL,
   theme tinyint(3) unsigned DEFAULT '0' NOT NULL,
   flags tinyint(3) unsigned DEFAULT '0' NOT NULL,
   ugroup smallint(5) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (userid),
   KEY userid (userid),
   UNIQUE userid_2 (userid)
);


