<?
/*

HPE - News Portal Engine
Copyright (C) 2000 Mike Krus

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


if(!defined("HPEprotectmultiincthememaker")) {
define("HPEprotectmultiincthememaker", 1);


$pv = phpversion();
require ($pv[0] == "4" ? "$HPEinc/class.FastTemplate.php" : "$HPEinc/class.FastTemplate.php3");


class HPEThemeMaker {

	var $id;
	var $imgpath;
	var $plain = 0;

	var $themepath;
	var $themeurl;
	var $mode = "";

	var $tpl;

	function HPEThemeMaker() 
	{
		global $HPEtheConfig;
		global $HPEinc;

		$this->themepath = $HPEtheConfig->themes[$HPEtheConfig->deftheme]["path"];
		$this->themeurl  = $HPEtheConfig->themes[$HPEtheConfig->deftheme]["url"];
	}


	function initTheme($id, $mode) 
	{
		global $HPEtheSession;
		global $HPEtheConfig;
		global $HPEinc;

		if(isset($HPEtheSession)) {

			$this->mode = ($mode == "normal" ? "" : $mode);
			if(isset($HPEtheConfig->themes[$HPEtheSession->theme])) {
				$this->themepath = $HPEtheConfig->themes[$HPEtheSession->theme]["path"];
				$this->themeurl  = $HPEtheConfig->themes[$HPEtheSession->theme]["url"];
			} else $HPEtheSession->theme = $HPEtheConfig->deftheme;

		}

		$HPEtheConfig->sitelogo[0] = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->sitelogo[0]);
		$HPEtheConfig->phpinclude = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->phpinclude);
		$HPEtheConfig->htmlbanner = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->htmlbanner);
		$HPEtheConfig->htmlplainbanner = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->htmlplainbanner);
		$HPEtheConfig->htmlfooter = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->htmlfooter);
		$HPEtheConfig->teaser = ereg_replace("^%HPEtheme%", $this->themeurl, $HPEtheConfig->teaser);
	}


	function TPLListModuleBegin($title, $link, $comment, $desc = "")
	{
		$this->tpl = new FastTemplate($this->themepath);
		
		$ex = $this->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		@$this->tpl->define( array( modulebox => $this->makeTPLName("modulelist") ) );
		@$this->tpl->define_dynamic( "items", "modulebox" );

		global $HPEtheConfig;
		global $HPEtheSession;
		if($desc == "") $desc = $title;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl,
									MODULEITEMTARGET => $HPEtheSession->extwin,
									MODULETITLE => $title,
									MODULELINK => $link,
									MODULEDESC => $desc,
									MODULECOMMENT => $comment ) );
	}


	function TPLListModuleAddItem($title, $link, $desc)
	{
		@$this->tpl->assign( array( MODULEITEMTEXT => $title,
							  MODULEITEMLINK => $link,
							  MODULEITEMCOMMENT => $desc ) );
		@$this->tpl->parse(ITEMS, ".items");
	}


	function TPLListModuleEnd()
	{
		@$this->tpl->parse(MAIN, "modulebox");
		return $this->tpl->fetch();
	}


	function TPLBlockModule($title, $link, $comment, $content, $desc = "")
	{
		$this->tpl = new FastTemplate($this->themepath);

		$ex = $this->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		@$this->tpl->define( array( modulebox => $this->makeTPLName("modulebox") ) );
		@$this->tpl->define_dynamic( "items", "modulebox" );

		global $HPEtheConfig;
		global $HPEtheSession;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl,
									MODULEITEMTARGET => $HPEtheSession->extwin,
									MODULETITLE => $title,
									MODULELINK => $link,
									MODULEDESC => $desc,
									MODULECONTENT => $content,
									MODULECOMMENT => $comment ) );
		@$this->tpl->parse(MAIN, "modulebox");
		return $this->tpl->fetch();
	}


	function TPLSectionBegin($title)
	{
		$this->tpl = new FastTemplate($this->themepath);

		$ex = $this->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		@$this->tpl->define( array( section => $this->makeTPLName("section.begin") ) );

		global $HPEtheConfig;
		global $HPEtheSession;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl,
									SECTIONTITLE => $title ) );
		@$this->tpl->parse(MAIN, "section");
		return $this->tpl->fetch();
	}


	function TPLSectionEnd()
	{
		$this->tpl = new FastTemplate($this->themepath);

		$ex = $this->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		@$this->tpl->define( array( section => $this->makeTPLName("section.end") ) );

		global $HPEtheConfig;
		global $HPEtheSession;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl ) );
		@$this->tpl->parse(MAIN, "section");
		return $this->tpl->fetch();
	}


	function TPLFrameBegin()
	{
		$this->tpl = new FastTemplate($this->themepath);

		@$this->tpl->define( array( frame => $this->makeTPLName("frame.begin") ) );

		global $HPEtheConfig;
		global $HPEtheSession;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl ) );
		@$this->tpl->parse(MAIN, "frame");
		return $this->tpl->fetch();
	}


	function TPLFrameEnd()
	{
		$this->tpl = new FastTemplate($this->themepath);

		@$this->tpl->define( array( frame => $this->makeTPLName("frame.end") ) );

		global $HPEtheConfig;
		global $HPEtheSession;
		@$this->tpl->assign( array( SITEROOT => $HPEtheConfig->siteroot,
									THEMEROOT => $this->themeurl ) );
		@$this->tpl->parse(MAIN, "frame");
		return $this->tpl->fetch();
	}


	function makeTPLName($base)
	{
		$ex = $this->mode;
		if($ex != "") $ex .= '.';
		$ex .= "tpl";
		if(file_exists($this->themepath . "/$base.$ex")) return "$base.$ex";
		return "$base.tpl";
	}


/*
	function TPLAssign($a)
	{
		@$this->tpl->assign( $a );
	}

	function TPLParse($t, $n)
	{
		@$this->tpl->parse( $t, $n );
	}

	function TPLFetch()
	{
		return $this->tpl->fetch();
	}
*/

};

$HPEtheThemeMaker = new HPEThemeMaker();




function beginframe($ocls = "", $icls = "")
{
	global $HPEtheThemeMaker;
	echo $HPEtheThemeMaker->TPLFrameBegin();
}


function endframe()
{
	global $HPEtheThemeMaker;
	echo $HPEtheThemeMaker->TPLFrameEnd();
}


function beginsection($section) 
{
	global $HPEtheThemeMaker;
	echo $HPEtheThemeMaker->TPLSectionBegin($section);
}


function endsection()
{
	global $HPEtheThemeMaker;
	echo $HPEtheThemeMaker->TPLSectionEnd();
}


} // $HPEprotectmultiincthememaker

?>
